// E2ETimeline.cpp : implementation file
//

#include "stdafx.h"
#include "Avionics.h"
#include "E2ETimeline.h"
#include "AIFRead.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CE2ETimeline dialog


CE2ETimeline::CE2ETimeline(CWnd* pParent /*=NULL*/)
	: CDialog(CE2ETimeline::IDD, pParent)
{
	//{{AFX_DATA_INIT(CE2ETimeline)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CE2ETimeline::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CE2ETimeline)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CE2ETimeline, CDialog)
	//{{AFX_MSG_MAP(CE2ETimeline)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CE2ETimeline message handlers

BOOL CE2ETimeline::OnInitDialog() 
{
	CDialog::OnInitDialog();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CE2ETimeline::OnPaint() 
{
	DrawTimeline(m_taskNode);
}

#define BAR_HEIGHT 18

void CE2ETimeline::DrawTimeline(CTaskNode *tNode) {
	ASSERT(tNode);
	CRect rect;
	GetClientRect(&rect);

	//First draw the white canvas.
	rect.DeflateRect(10, 10);
	CPaintDC dc(this);
	dc.Rectangle(rect);

	//Shrink the rectangle further to draw the actual timeline graph.
	rect.DeflateRect(10, 10);

	int xbase = rect.TopLeft().x;
	int xend = rect.BottomRight().x;
	int ybase = rect.BottomRight().y;
	int ytop = rect.TopLeft().y;
   
//	CTaskNode* tailNode = tChain->taskNodeList.GetTail();
//	if(!tailNode) return;

	//double last = MAX(tailNode->deadline, tailNode->wcrt) * 1.1;
	double period = (double)GetPeriodFromRate(tNode->rate);
	double last = period * 1.1;
	double scale = last/rect.Width();

	dc.MoveTo(xbase, ybase);
	dc.LineTo(xbase, ytop);
	dc.MoveTo(xbase, ybase);
	dc.LineTo(xend, ybase);
	
	CPen redPen(PS_SOLID,2,RGB(255,0,0));
	CPen *pOldPen = dc.SelectObject(&redPen);
//	dc.MoveTo(tailNode->deadline/scale, ybase);
//	dc.LineTo(tailNode->deadline/scale, ytop);
	dc.MoveTo(period/scale, ybase);
	dc.LineTo(period/scale, ytop);
	dc.SelectObject(pOldPen);
	CString temp;
	temp.Format("Deadline:%.0lfus", period);
	dc.TextOut(period/scale - 70, ytop, temp);

	CBrush blueBrush(RGB(0, 0, 255));
	CBrush greenBrush(RGB(0, 255, 0));

//	edge e = gTheSystem.theTG.firstout(tNode->index);
	//POSITION pos = tChain->taskNodeList.GetHeadPosition();
	double time = 0;
	int step = 1;
	double start = 0.0;
	edge e = 0;
	while(true) {
		//CTaskNode *taskNode = tChain->taskNodeList.GetNext(pos);
		//double start = time;
		time = tNode->wcrt;
		
		CRect rect2(xbase + start/scale, ybase - BAR_HEIGHT * step,
			xbase + tNode->wcrt/scale, ybase - BAR_HEIGHT * (step - 1));
		CBrush *pOldBrush = dc.SelectObject(&blueBrush);
		dc.Rectangle(rect2);
		dc.SelectObject(pOldBrush);
		CString label;
		label.Format("%s(%.2lf, %.2lf)", tNode->GetName(), tNode->bcrt, tNode->wcrt);
		dc.TextOut(rect2.right, rect2.top, label);
		
		CRect rect3(xbase + tNode->bcrt/scale, ybase - BAR_HEIGHT * step,
			xbase + tNode->wcrt/scale, ybase - BAR_HEIGHT * (step - 1));
		pOldBrush = dc.SelectObject(&greenBrush);
		dc.Rectangle(rect3);
		dc.SelectObject(pOldBrush);
		
		step++;
		
		e = gTheSystem.theTG.firstout(tNode->index);
		if(e == 0) break;
		tNode = gTheSystem.theTG.get_task_node(gTheSystem.theTG.head(e));
	//	e = gTheSystem.theTG.firstout(head(e));	
	}

}

/*	
		CString cs;
		cs.Format("%d:%d:%d:%d, start %.2lf, scale %.2lf", rect2.TopLeft().x, rect2.TopLeft().y,
					rect2.BottomRight().x, rect2.BottomRight().y, start, scale);
		AfxMessageBox(cs);
	*/