#ifndef MOBIES_IIF_H
#define MOBIES_IIF_H
// header file IIF.h generated from diagram IIF
// generated on Wed Nov 13 21:01:05 2002

#ifndef MOBIES_UDMBASE_H
#include "UdmBase.h"
#endif

namespace IIF {

	typedef Udm::Object Object;

	class System;
	class PreemptionTimeStamp;
	class Process;
	class Processor;
	class Network;
	class OperatingSystem;
	class Thread;
	class FrameController;
	class TimeService;
	class PersistenceService;
	class IIFObject;
	class Schedule;
	class Component;
	class EventPort;
	class EventChannel;
	class Scheduler;
	class Timer;
	class DispatchingQueue;
	class Rate;
	class PublishPort;
	class SubscribePort;
	class Event;
	class Action;
	class ComponentMode;
	class EventDependencyTimeStamp;
	class SuppliedEventTimeStamp;
	class QueueReorderingTimeStamp;
	class FrameTimeStamp;
	class ThreadedTimeStamp;
	class ModeTimeStamp;
	class ConsumedEventTimeStamp;
	class RemoteMethodTimeStamp;
	class Timestamp;

	void Initialize();
	extern Udm::UdmDiagram diagram;

	class System :  public Object {
	 public:
		static Uml::Class meta;

		System() { }
		System(Udm::ObjectImpl *impl) : Object(impl) { }
		System(const System &master) : Object(master) { }
		static System Cast(const Object &a) { return __Cast(a, meta); }

		static System Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_globalClockSkew;
		Udm::IntegerAttr globalClockSkew() const { return Udm::IntegerAttr(impl, meta_globalClockSkew); }

		static Uml::CompositionChildRole meta_Timestamp_children;
		Udm::ChildrenAttr<IIF::Timestamp> Timestamp_children() const { return Udm::ChildrenAttr<IIF::Timestamp>(impl, meta_Timestamp_children); }

		static Uml::CompositionChildRole meta_Network_children;
		Udm::ChildrenAttr<IIF::Network> Network_children() const { return Udm::ChildrenAttr<IIF::Network>(impl, meta_Network_children); }

		static Uml::CompositionChildRole meta_Processor_children;
		Udm::ChildrenAttr<IIF::Processor> Processor_children() const { return Udm::ChildrenAttr<IIF::Processor>(impl, meta_Processor_children); }

		Udm::ChildrenAttr<IIF::PreemptionTimeStamp> PreemptionTimeStamp_kind_children() const { return Udm::ChildrenAttr<IIF::PreemptionTimeStamp>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::Processor> Processor_kind_children() const { return Udm::ChildrenAttr<IIF::Processor>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::Network> Network_kind_children() const { return Udm::ChildrenAttr<IIF::Network>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::IIFObject> IIFObject_kind_children() const { return Udm::ChildrenAttr<IIF::IIFObject>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::EventDependencyTimeStamp> EventDependencyTimeStamp_kind_children() const { return Udm::ChildrenAttr<IIF::EventDependencyTimeStamp>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::SuppliedEventTimeStamp> SuppliedEventTimeStamp_kind_children() const { return Udm::ChildrenAttr<IIF::SuppliedEventTimeStamp>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::QueueReorderingTimeStamp> QueueReorderingTimeStamp_kind_children() const { return Udm::ChildrenAttr<IIF::QueueReorderingTimeStamp>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::FrameTimeStamp> FrameTimeStamp_kind_children() const { return Udm::ChildrenAttr<IIF::FrameTimeStamp>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::ThreadedTimeStamp> ThreadedTimeStamp_kind_children() const { return Udm::ChildrenAttr<IIF::ThreadedTimeStamp>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::ModeTimeStamp> ModeTimeStamp_kind_children() const { return Udm::ChildrenAttr<IIF::ModeTimeStamp>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::ConsumedEventTimeStamp> ConsumedEventTimeStamp_kind_children() const { return Udm::ChildrenAttr<IIF::ConsumedEventTimeStamp>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::RemoteMethodTimeStamp> RemoteMethodTimeStamp_kind_children() const { return Udm::ChildrenAttr<IIF::RemoteMethodTimeStamp>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::Timestamp> Timestamp_kind_children() const { return Udm::ChildrenAttr<IIF::Timestamp>(impl, Udm::NULLCHILDROLE); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class IIFObject :  public Object {
	 public:
		static Uml::Class meta;

		IIFObject() { }
		IIFObject(Udm::ObjectImpl *impl) : Object(impl) { }
		IIFObject(const IIFObject &master) : Object(master) { }
		static IIFObject Cast(const Object &a) { return __Cast(a, meta); }

		static IIFObject Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_name;
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class Process :  public IIFObject {
	 public:
		static Uml::Class meta;

		Process() { }
		Process(Udm::ObjectImpl *impl) : IIFObject(impl) { }
		Process(const Process &master) : IIFObject(master) { }
		static Process Cast(const Object &a) { return __Cast(a, meta); }

		static Process Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_processNumber;
		Udm::IntegerAttr processNumber() const { return Udm::IntegerAttr(impl, meta_processNumber); }

		static Uml::CompositionChildRole meta_EventChannel_child;
		Udm::ChildAttr<IIF::EventChannel> EventChannel_child() const { return Udm::ChildAttr<IIF::EventChannel>(impl, meta_EventChannel_child); }

		static Uml::CompositionChildRole meta_Thread_children;
		Udm::ChildrenAttr<IIF::Thread> Thread_children() const { return Udm::ChildrenAttr<IIF::Thread>(impl, meta_Thread_children); }

		static Uml::CompositionChildRole meta_Scheduler_child;
		Udm::ChildAttr<IIF::Scheduler> Scheduler_child() const { return Udm::ChildAttr<IIF::Scheduler>(impl, meta_Scheduler_child); }

		static Uml::CompositionChildRole meta_Component_children;
		Udm::ChildrenAttr<IIF::Component> Component_children() const { return Udm::ChildrenAttr<IIF::Component>(impl, meta_Component_children); }

		static Uml::CompositionChildRole meta_FrameController_child;
		Udm::ChildAttr<IIF::FrameController> FrameController_child() const { return Udm::ChildAttr<IIF::FrameController>(impl, meta_FrameController_child); }

		static Uml::CompositionChildRole meta_TimeService_child;
		Udm::ChildAttr<IIF::TimeService> TimeService_child() const { return Udm::ChildAttr<IIF::TimeService>(impl, meta_TimeService_child); }

		static Uml::CompositionChildRole meta_PersistenceService_child;
		Udm::ChildAttr<IIF::PersistenceService> PersistenceService_child() const { return Udm::ChildAttr<IIF::PersistenceService>(impl, meta_PersistenceService_child); }

		Udm::ChildrenAttr<IIF::Thread> Thread_kind_children() const { return Udm::ChildrenAttr<IIF::Thread>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::FrameController> FrameController_kind_children() const { return Udm::ChildrenAttr<IIF::FrameController>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::TimeService> TimeService_kind_children() const { return Udm::ChildrenAttr<IIF::TimeService>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::PersistenceService> PersistenceService_kind_children() const { return Udm::ChildrenAttr<IIF::PersistenceService>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::IIFObject> IIFObject_kind_children() const { return Udm::ChildrenAttr<IIF::IIFObject>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::Component> Component_kind_children() const { return Udm::ChildrenAttr<IIF::Component>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::EventChannel> EventChannel_kind_children() const { return Udm::ChildrenAttr<IIF::EventChannel>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::Scheduler> Scheduler_kind_children() const { return Udm::ChildrenAttr<IIF::Scheduler>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_Processor_parent;
		Udm::ParentAttr<IIF::Processor> Processor_parent() const { return Udm::ParentAttr<IIF::Processor>(impl, meta_Processor_parent); }

		Udm::ParentAttr<IIF::IIFObject> parent() const { return Udm::ParentAttr<IIF::IIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class Processor :  public IIFObject {
	 public:
		static Uml::Class meta;

		Processor() { }
		Processor(Udm::ObjectImpl *impl) : IIFObject(impl) { }
		Processor(const Processor &master) : IIFObject(master) { }
		static Processor Cast(const Object &a) { return __Cast(a, meta); }

		static Processor Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_processorBusSpeed;
		Udm::IntegerAttr processorBusSpeed() const { return Udm::IntegerAttr(impl, meta_processorBusSpeed); }

		static Uml::Attribute meta_processorSpeed;
		Udm::IntegerAttr processorSpeed() const { return Udm::IntegerAttr(impl, meta_processorSpeed); }

		static Uml::Attribute meta_processorMemory;
		Udm::IntegerAttr processorMemory() const { return Udm::IntegerAttr(impl, meta_processorMemory); }

		static Uml::Attribute meta_clockRes;
		Udm::IntegerAttr clockRes() const { return Udm::IntegerAttr(impl, meta_clockRes); }

		static Uml::AssociationRole meta_Network;
		Udm::AssocAttr<IIF::Network> Network() const { return Udm::AssocAttr<IIF::Network>(impl, meta_Network); }

		static Uml::CompositionChildRole meta_OperatingSystem_child;
		Udm::ChildAttr<IIF::OperatingSystem> OperatingSystem_child() const { return Udm::ChildAttr<IIF::OperatingSystem>(impl, meta_OperatingSystem_child); }

		static Uml::CompositionChildRole meta_Process_children;
		Udm::ChildrenAttr<IIF::Process> Process_children() const { return Udm::ChildrenAttr<IIF::Process>(impl, meta_Process_children); }

		Udm::ChildrenAttr<IIF::Process> Process_kind_children() const { return Udm::ChildrenAttr<IIF::Process>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::OperatingSystem> OperatingSystem_kind_children() const { return Udm::ChildrenAttr<IIF::OperatingSystem>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::IIFObject> IIFObject_kind_children() const { return Udm::ChildrenAttr<IIF::IIFObject>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_System_parent;
		Udm::ParentAttr<IIF::System> System_parent() const { return Udm::ParentAttr<IIF::System>(impl, meta_System_parent); }

		Udm::ParentAttr<IIF::System> parent() const { return Udm::ParentAttr<IIF::System>(impl, Udm::NULLPARENTROLE); }
	};

	class Network :  public IIFObject {
	 public:
		static Uml::Class meta;

		Network() { }
		Network(Udm::ObjectImpl *impl) : IIFObject(impl) { }
		Network(const Network &master) : IIFObject(master) { }
		static Network Cast(const Object &a) { return __Cast(a, meta); }

		static Network Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_networkLatency;
		Udm::IntegerAttr networkLatency() const { return Udm::IntegerAttr(impl, meta_networkLatency); }

		static Uml::Attribute meta_networkBandwidth;
		Udm::IntegerAttr networkBandwidth() const { return Udm::IntegerAttr(impl, meta_networkBandwidth); }

		static Uml::AssociationRole meta_Processor;
		Udm::AssocAttr<IIF::Processor> Processor() const { return Udm::AssocAttr<IIF::Processor>(impl, meta_Processor); }

		static Uml::CompositionParentRole meta_System_parent;
		Udm::ParentAttr<IIF::System> System_parent() const { return Udm::ParentAttr<IIF::System>(impl, meta_System_parent); }

		Udm::ParentAttr<IIF::System> parent() const { return Udm::ParentAttr<IIF::System>(impl, Udm::NULLPARENTROLE); }
	};

	class OperatingSystem :  public IIFObject {
	 public:
		static Uml::Class meta;

		OperatingSystem() { }
		OperatingSystem(Udm::ObjectImpl *impl) : IIFObject(impl) { }
		OperatingSystem(const OperatingSystem &master) : IIFObject(master) { }
		static OperatingSystem Cast(const Object &a) { return __Cast(a, meta); }

		static OperatingSystem Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_schedulingPolicyId;
		Udm::StringAttr schedulingPolicyId() const { return Udm::StringAttr(impl, meta_schedulingPolicyId); }

		static Uml::Attribute meta_numThreadPriorities;
		Udm::IntegerAttr numThreadPriorities() const { return Udm::IntegerAttr(impl, meta_numThreadPriorities); }

		static Uml::CompositionParentRole meta_Processor_parent;
		Udm::ParentAttr<IIF::Processor> Processor_parent() const { return Udm::ParentAttr<IIF::Processor>(impl, meta_Processor_parent); }

		Udm::ParentAttr<IIF::IIFObject> parent() const { return Udm::ParentAttr<IIF::IIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class Thread :  public IIFObject {
	 public:
		static Uml::Class meta;

		Thread() { }
		Thread(Udm::ObjectImpl *impl) : IIFObject(impl) { }
		Thread(const Thread &master) : IIFObject(master) { }
		static Thread Cast(const Object &a) { return __Cast(a, meta); }

		static Thread Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_stackSize;
		Udm::IntegerAttr stackSize() const { return Udm::IntegerAttr(impl, meta_stackSize); }

		static Uml::Attribute meta_threadPriority;
		Udm::IntegerAttr threadPriority() const { return Udm::IntegerAttr(impl, meta_threadPriority); }

		static Uml::AssociationRole meta_PreemptionTimeStamp;
		Udm::PointerAttr<IIF::PreemptionTimeStamp> PreemptionTimeStamp() const { return Udm::PointerAttr<IIF::PreemptionTimeStamp>(impl, meta_PreemptionTimeStamp); }

		static Uml::AssociationRole meta_ThreadedTimeStamp;
		Udm::AssocAttr<IIF::ThreadedTimeStamp> ThreadedTimeStamp() const { return Udm::AssocAttr<IIF::ThreadedTimeStamp>(impl, meta_ThreadedTimeStamp); }

		static Uml::AssociationRole meta_DispatchingQueue;
		Udm::PointerAttr<IIF::DispatchingQueue> DispatchingQueue() const { return Udm::PointerAttr<IIF::DispatchingQueue>(impl, meta_DispatchingQueue); }

		static Uml::CompositionChildRole meta_Rate_child;
		Udm::ChildAttr<IIF::Rate> Rate_child() const { return Udm::ChildAttr<IIF::Rate>(impl, meta_Rate_child); }

		Udm::ChildrenAttr<IIF::IIFObject> IIFObject_kind_children() const { return Udm::ChildrenAttr<IIF::IIFObject>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::Rate> Rate_kind_children() const { return Udm::ChildrenAttr<IIF::Rate>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_Process_parent;
		Udm::ParentAttr<IIF::Process> Process_parent() const { return Udm::ParentAttr<IIF::Process>(impl, meta_Process_parent); }

		Udm::ParentAttr<IIF::IIFObject> parent() const { return Udm::ParentAttr<IIF::IIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class FrameController :  public IIFObject {
	 public:
		static Uml::Class meta;

		FrameController() { }
		FrameController(Udm::ObjectImpl *impl) : IIFObject(impl) { }
		FrameController(const FrameController &master) : IIFObject(master) { }
		static FrameController Cast(const Object &a) { return __Cast(a, meta); }

		static FrameController Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::CompositionChildRole meta_EventPort_children;
		Udm::ChildrenAttr<IIF::EventPort> EventPort_children() const { return Udm::ChildrenAttr<IIF::EventPort>(impl, meta_EventPort_children); }

		Udm::ChildrenAttr<IIF::IIFObject> IIFObject_kind_children() const { return Udm::ChildrenAttr<IIF::IIFObject>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::EventPort> EventPort_kind_children() const { return Udm::ChildrenAttr<IIF::EventPort>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::PublishPort> PublishPort_kind_children() const { return Udm::ChildrenAttr<IIF::PublishPort>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::SubscribePort> SubscribePort_kind_children() const { return Udm::ChildrenAttr<IIF::SubscribePort>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_Process_parent;
		Udm::ParentAttr<IIF::Process> Process_parent() const { return Udm::ParentAttr<IIF::Process>(impl, meta_Process_parent); }

		Udm::ParentAttr<IIF::IIFObject> parent() const { return Udm::ParentAttr<IIF::IIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class TimeService :  public IIFObject {
	 public:
		static Uml::Class meta;

		TimeService() { }
		TimeService(Udm::ObjectImpl *impl) : IIFObject(impl) { }
		TimeService(const TimeService &master) : IIFObject(master) { }
		static TimeService Cast(const Object &a) { return __Cast(a, meta); }

		static TimeService Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::CompositionChildRole meta_EventPort_children;
		Udm::ChildrenAttr<IIF::EventPort> EventPort_children() const { return Udm::ChildrenAttr<IIF::EventPort>(impl, meta_EventPort_children); }

		Udm::ChildrenAttr<IIF::IIFObject> IIFObject_kind_children() const { return Udm::ChildrenAttr<IIF::IIFObject>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::EventPort> EventPort_kind_children() const { return Udm::ChildrenAttr<IIF::EventPort>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::PublishPort> PublishPort_kind_children() const { return Udm::ChildrenAttr<IIF::PublishPort>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::SubscribePort> SubscribePort_kind_children() const { return Udm::ChildrenAttr<IIF::SubscribePort>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_Process_parent;
		Udm::ParentAttr<IIF::Process> Process_parent() const { return Udm::ParentAttr<IIF::Process>(impl, meta_Process_parent); }

		Udm::ParentAttr<IIF::IIFObject> parent() const { return Udm::ParentAttr<IIF::IIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class PersistenceService :  public IIFObject {
	 public:
		static Uml::Class meta;

		PersistenceService() { }
		PersistenceService(Udm::ObjectImpl *impl) : IIFObject(impl) { }
		PersistenceService(const PersistenceService &master) : IIFObject(master) { }
		static PersistenceService Cast(const Object &a) { return __Cast(a, meta); }

		static PersistenceService Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::CompositionChildRole meta_EventPort_children;
		Udm::ChildrenAttr<IIF::EventPort> EventPort_children() const { return Udm::ChildrenAttr<IIF::EventPort>(impl, meta_EventPort_children); }

		Udm::ChildrenAttr<IIF::IIFObject> IIFObject_kind_children() const { return Udm::ChildrenAttr<IIF::IIFObject>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::EventPort> EventPort_kind_children() const { return Udm::ChildrenAttr<IIF::EventPort>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::PublishPort> PublishPort_kind_children() const { return Udm::ChildrenAttr<IIF::PublishPort>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::SubscribePort> SubscribePort_kind_children() const { return Udm::ChildrenAttr<IIF::SubscribePort>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_Process_parent;
		Udm::ParentAttr<IIF::Process> Process_parent() const { return Udm::ParentAttr<IIF::Process>(impl, meta_Process_parent); }

		Udm::ParentAttr<IIF::IIFObject> parent() const { return Udm::ParentAttr<IIF::IIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class Schedule :  public IIFObject {
	 public:
		static Uml::Class meta;

		Schedule() { }
		Schedule(Udm::ObjectImpl *impl) : IIFObject(impl) { }
		Schedule(const Schedule &master) : IIFObject(master) { }
		static Schedule Cast(const Object &a) { return __Cast(a, meta); }

		static Schedule Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::AssociationRole meta_Component;
		Udm::AssocAttr<IIF::Component> Component() const { return Udm::AssocAttr<IIF::Component>(impl, meta_Component); }

		static Uml::AssociationRole meta_dispatchingQueue;
		Udm::AssocAttr<IIF::DispatchingQueue> dispatchingQueue() const { return Udm::AssocAttr<IIF::DispatchingQueue>(impl, meta_dispatchingQueue); }

		static Uml::CompositionParentRole meta_Scheduler_parent;
		Udm::ParentAttr<IIF::Scheduler> Scheduler_parent() const { return Udm::ParentAttr<IIF::Scheduler>(impl, meta_Scheduler_parent); }

		Udm::ParentAttr<IIF::IIFObject> parent() const { return Udm::ParentAttr<IIF::IIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class Component :  public IIFObject {
	 public:
		static Uml::Class meta;

		Component() { }
		Component(Udm::ObjectImpl *impl) : IIFObject(impl) { }
		Component(const Component &master) : IIFObject(master) { }
		static Component Cast(const Object &a) { return __Cast(a, meta); }

		static Component Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_GroupId;
		Udm::IntegerAttr GroupId() const { return Udm::IntegerAttr(impl, meta_GroupId); }

		static Uml::Attribute meta_ItemId;
		Udm::IntegerAttr ItemId() const { return Udm::IntegerAttr(impl, meta_ItemId); }

		static Uml::Attribute meta_componentSize;
		Udm::IntegerAttr componentSize() const { return Udm::IntegerAttr(impl, meta_componentSize); }

		static Uml::AssociationRole meta_Schedule;
		Udm::PointerAttr<IIF::Schedule> Schedule() const { return Udm::PointerAttr<IIF::Schedule>(impl, meta_Schedule); }

		static Uml::AssociationRole meta_ComponentMode;
		Udm::PointerAttr<IIF::ComponentMode> ComponentMode() const { return Udm::PointerAttr<IIF::ComponentMode>(impl, meta_ComponentMode); }

		static Uml::CompositionChildRole meta_Action_children;
		Udm::ChildrenAttr<IIF::Action> Action_children() const { return Udm::ChildrenAttr<IIF::Action>(impl, meta_Action_children); }

		static Uml::CompositionChildRole meta_EventPort_children;
		Udm::ChildrenAttr<IIF::EventPort> EventPort_children() const { return Udm::ChildrenAttr<IIF::EventPort>(impl, meta_EventPort_children); }

		Udm::ChildrenAttr<IIF::IIFObject> IIFObject_kind_children() const { return Udm::ChildrenAttr<IIF::IIFObject>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::EventPort> EventPort_kind_children() const { return Udm::ChildrenAttr<IIF::EventPort>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::PublishPort> PublishPort_kind_children() const { return Udm::ChildrenAttr<IIF::PublishPort>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::SubscribePort> SubscribePort_kind_children() const { return Udm::ChildrenAttr<IIF::SubscribePort>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::Action> Action_kind_children() const { return Udm::ChildrenAttr<IIF::Action>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_owner;
		Udm::ParentAttr<IIF::Process> owner() const { return Udm::ParentAttr<IIF::Process>(impl, meta_owner); }

		Udm::ParentAttr<IIF::IIFObject> parent() const { return Udm::ParentAttr<IIF::IIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class EventPort :  public IIFObject {
	 public:
		static Uml::Class meta;

		EventPort() { }
		EventPort(Udm::ObjectImpl *impl) : IIFObject(impl) { }
		EventPort(const EventPort &master) : IIFObject(master) { }
		static EventPort Cast(const Object &a) { return __Cast(a, meta); }

		static EventPort Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::CompositionParentRole meta_Component_parent;
		Udm::ParentAttr<IIF::Component> Component_parent() const { return Udm::ParentAttr<IIF::Component>(impl, meta_Component_parent); }

		static Uml::CompositionParentRole meta_TimeService_parent;
		Udm::ParentAttr<IIF::TimeService> TimeService_parent() const { return Udm::ParentAttr<IIF::TimeService>(impl, meta_TimeService_parent); }

		static Uml::CompositionParentRole meta_FrameController_parent;
		Udm::ParentAttr<IIF::FrameController> FrameController_parent() const { return Udm::ParentAttr<IIF::FrameController>(impl, meta_FrameController_parent); }

		static Uml::CompositionParentRole meta_PersistenceService_parent;
		Udm::ParentAttr<IIF::PersistenceService> PersistenceService_parent() const { return Udm::ParentAttr<IIF::PersistenceService>(impl, meta_PersistenceService_parent); }

		Udm::ParentAttr<IIF::IIFObject> parent() const { return Udm::ParentAttr<IIF::IIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class EventChannel :  public IIFObject {
	 public:
		static Uml::Class meta;

		EventChannel() { }
		EventChannel(Udm::ObjectImpl *impl) : IIFObject(impl) { }
		EventChannel(const EventChannel &master) : IIFObject(master) { }
		static EventChannel Cast(const Object &a) { return __Cast(a, meta); }

		static EventChannel Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::AssociationRole meta_Scheduler;
		Udm::PointerAttr<IIF::Scheduler> Scheduler() const { return Udm::PointerAttr<IIF::Scheduler>(impl, meta_Scheduler); }

		static Uml::CompositionChildRole meta_DispatchingQueue_children;
		Udm::ChildrenAttr<IIF::DispatchingQueue> DispatchingQueue_children() const { return Udm::ChildrenAttr<IIF::DispatchingQueue>(impl, meta_DispatchingQueue_children); }

		static Uml::CompositionChildRole meta_Timer_children;
		Udm::ChildrenAttr<IIF::Timer> Timer_children() const { return Udm::ChildrenAttr<IIF::Timer>(impl, meta_Timer_children); }

		Udm::ChildrenAttr<IIF::IIFObject> IIFObject_kind_children() const { return Udm::ChildrenAttr<IIF::IIFObject>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::Timer> Timer_kind_children() const { return Udm::ChildrenAttr<IIF::Timer>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::DispatchingQueue> DispatchingQueue_kind_children() const { return Udm::ChildrenAttr<IIF::DispatchingQueue>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_Process_parent;
		Udm::ParentAttr<IIF::Process> Process_parent() const { return Udm::ParentAttr<IIF::Process>(impl, meta_Process_parent); }

		Udm::ParentAttr<IIF::IIFObject> parent() const { return Udm::ParentAttr<IIF::IIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class Scheduler :  public IIFObject {
	 public:
		static Uml::Class meta;

		Scheduler() { }
		Scheduler(Udm::ObjectImpl *impl) : IIFObject(impl) { }
		Scheduler(const Scheduler &master) : IIFObject(master) { }
		static Scheduler Cast(const Object &a) { return __Cast(a, meta); }

		static Scheduler Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::AssociationRole meta_EventChannel;
		Udm::PointerAttr<IIF::EventChannel> EventChannel() const { return Udm::PointerAttr<IIF::EventChannel>(impl, meta_EventChannel); }

		static Uml::CompositionChildRole meta_Schedule_children;
		Udm::ChildrenAttr<IIF::Schedule> Schedule_children() const { return Udm::ChildrenAttr<IIF::Schedule>(impl, meta_Schedule_children); }

		Udm::ChildrenAttr<IIF::IIFObject> IIFObject_kind_children() const { return Udm::ChildrenAttr<IIF::IIFObject>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::Schedule> Schedule_kind_children() const { return Udm::ChildrenAttr<IIF::Schedule>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_Process_parent;
		Udm::ParentAttr<IIF::Process> Process_parent() const { return Udm::ParentAttr<IIF::Process>(impl, meta_Process_parent); }

		Udm::ParentAttr<IIF::IIFObject> parent() const { return Udm::ParentAttr<IIF::IIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class Timer :  public IIFObject {
	 public:
		static Uml::Class meta;

		Timer() { }
		Timer(Udm::ObjectImpl *impl) : IIFObject(impl) { }
		Timer(const Timer &master) : IIFObject(master) { }
		static Timer Cast(const Object &a) { return __Cast(a, meta); }

		static Timer Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::AssociationRole meta_rate;
		Udm::PointerAttr<IIF::Rate> rate() const { return Udm::PointerAttr<IIF::Rate>(impl, meta_rate); }

		static Uml::CompositionChildRole meta_PublishPort_children;
		Udm::ChildrenAttr<IIF::PublishPort> PublishPort_children() const { return Udm::ChildrenAttr<IIF::PublishPort>(impl, meta_PublishPort_children); }

		Udm::ChildrenAttr<IIF::IIFObject> IIFObject_kind_children() const { return Udm::ChildrenAttr<IIF::IIFObject>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::EventPort> EventPort_kind_children() const { return Udm::ChildrenAttr<IIF::EventPort>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::PublishPort> PublishPort_kind_children() const { return Udm::ChildrenAttr<IIF::PublishPort>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_EventChannel_parent;
		Udm::ParentAttr<IIF::EventChannel> EventChannel_parent() const { return Udm::ParentAttr<IIF::EventChannel>(impl, meta_EventChannel_parent); }

		Udm::ParentAttr<IIF::IIFObject> parent() const { return Udm::ParentAttr<IIF::IIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class DispatchingQueue :  public IIFObject {
	 public:
		static Uml::Class meta;

		DispatchingQueue() { }
		DispatchingQueue(Udm::ObjectImpl *impl) : IIFObject(impl) { }
		DispatchingQueue(const DispatchingQueue &master) : IIFObject(master) { }
		static DispatchingQueue Cast(const Object &a) { return __Cast(a, meta); }

		static DispatchingQueue Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_dispatchingQueueSize;
		Udm::IntegerAttr dispatchingQueueSize() const { return Udm::IntegerAttr(impl, meta_dispatchingQueueSize); }

		static Uml::Attribute meta_dispatchingQueueId;
		Udm::IntegerAttr dispatchingQueueId() const { return Udm::IntegerAttr(impl, meta_dispatchingQueueId); }

		static Uml::AssociationRole meta_servicedBy;
		Udm::AssocAttr<IIF::Thread> servicedBy() const { return Udm::AssocAttr<IIF::Thread>(impl, meta_servicedBy); }

		static Uml::AssociationRole meta_Schedule;
		Udm::PointerAttr<IIF::Schedule> Schedule() const { return Udm::PointerAttr<IIF::Schedule>(impl, meta_Schedule); }

		static Uml::AssociationRole meta_QueueReorderingTimeStamp;
		Udm::AssocAttr<IIF::QueueReorderingTimeStamp> QueueReorderingTimeStamp() const { return Udm::AssocAttr<IIF::QueueReorderingTimeStamp>(impl, meta_QueueReorderingTimeStamp); }

		static Uml::CompositionParentRole meta_EventChannel_parent;
		Udm::ParentAttr<IIF::EventChannel> EventChannel_parent() const { return Udm::ParentAttr<IIF::EventChannel>(impl, meta_EventChannel_parent); }

		Udm::ParentAttr<IIF::IIFObject> parent() const { return Udm::ParentAttr<IIF::IIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class Rate :  public IIFObject {
	 public:
		static Uml::Class meta;

		Rate() { }
		Rate(Udm::ObjectImpl *impl) : IIFObject(impl) { }
		Rate(const Rate &master) : IIFObject(master) { }
		static Rate Cast(const Object &a) { return __Cast(a, meta); }

		static Rate Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::AssociationRole meta_Timer;
		Udm::AssocAttr<IIF::Timer> Timer() const { return Udm::AssocAttr<IIF::Timer>(impl, meta_Timer); }

		static Uml::AssociationRole meta_FrameTimeStamp;
		Udm::AssocAttr<IIF::FrameTimeStamp> FrameTimeStamp() const { return Udm::AssocAttr<IIF::FrameTimeStamp>(impl, meta_FrameTimeStamp); }

		static Uml::CompositionParentRole meta_Thread_parent;
		Udm::ParentAttr<IIF::Thread> Thread_parent() const { return Udm::ParentAttr<IIF::Thread>(impl, meta_Thread_parent); }

		Udm::ParentAttr<IIF::IIFObject> parent() const { return Udm::ParentAttr<IIF::IIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class PublishPort :  public EventPort {
	 public:
		static Uml::Class meta;

		PublishPort() { }
		PublishPort(Udm::ObjectImpl *impl) : EventPort(impl) { }
		PublishPort(const PublishPort &master) : EventPort(master) { }
		static PublishPort Cast(const Object &a) { return __Cast(a, meta); }

		static PublishPort Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::AssociationRole meta_ConsumedEventTimeStamp;
		Udm::AssocAttr<IIF::ConsumedEventTimeStamp> ConsumedEventTimeStamp() const { return Udm::AssocAttr<IIF::ConsumedEventTimeStamp>(impl, meta_ConsumedEventTimeStamp); }

		static Uml::AssociationRole meta_SuppliedEventTimeStamp;
		Udm::AssocAttr<IIF::SuppliedEventTimeStamp> SuppliedEventTimeStamp() const { return Udm::AssocAttr<IIF::SuppliedEventTimeStamp>(impl, meta_SuppliedEventTimeStamp); }

		static Uml::CompositionChildRole meta_Event_children;
		Udm::ChildrenAttr<IIF::Event> Event_children() const { return Udm::ChildrenAttr<IIF::Event>(impl, meta_Event_children); }

		Udm::ChildrenAttr<IIF::IIFObject> IIFObject_kind_children() const { return Udm::ChildrenAttr<IIF::IIFObject>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<IIF::Event> Event_kind_children() const { return Udm::ChildrenAttr<IIF::Event>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_Timer_parent;
		Udm::ParentAttr<IIF::Timer> Timer_parent() const { return Udm::ParentAttr<IIF::Timer>(impl, meta_Timer_parent); }

		Udm::ParentAttr<IIF::IIFObject> parent() const { return Udm::ParentAttr<IIF::IIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class SubscribePort :  public EventPort {
	 public:
		static Uml::Class meta;

		SubscribePort() { }
		SubscribePort(Udm::ObjectImpl *impl) : EventPort(impl) { }
		SubscribePort(const SubscribePort &master) : EventPort(master) { }
		static SubscribePort Cast(const Object &a) { return __Cast(a, meta); }

		static SubscribePort Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_isERM_Subscriber;
		Udm::BooleanAttr isERM_Subscriber() const { return Udm::BooleanAttr(impl, meta_isERM_Subscriber); }

		static Uml::Attribute meta_eventsCorrelated;
		Udm::BooleanAttr eventsCorrelated() const { return Udm::BooleanAttr(impl, meta_eventsCorrelated); }

		static Uml::AssociationRole meta_ConsumedEventTimeStamp;
		Udm::AssocAttr<IIF::ConsumedEventTimeStamp> ConsumedEventTimeStamp() const { return Udm::AssocAttr<IIF::ConsumedEventTimeStamp>(impl, meta_ConsumedEventTimeStamp); }

		static Uml::AssociationRole meta_EventDependencyTimeStamp;
		Udm::AssocAttr<IIF::EventDependencyTimeStamp> EventDependencyTimeStamp() const { return Udm::AssocAttr<IIF::EventDependencyTimeStamp>(impl, meta_EventDependencyTimeStamp); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class Event :  public IIFObject {
	 public:
		static Uml::Class meta;

		Event() { }
		Event(Udm::ObjectImpl *impl) : IIFObject(impl) { }
		Event(const Event &master) : IIFObject(master) { }
		static Event Cast(const Object &a) { return __Cast(a, meta); }

		static Event Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_eventSourceTypeId;
		Udm::IntegerAttr eventSourceTypeId() const { return Udm::IntegerAttr(impl, meta_eventSourceTypeId); }

		static Uml::AssociationRole meta_eventtimestamp;
		Udm::AssocAttr<IIF::EventDependencyTimeStamp> eventtimestamp() const { return Udm::AssocAttr<IIF::EventDependencyTimeStamp>(impl, meta_eventtimestamp); }

		static Uml::AssociationRole meta_eventtimestamps;
		Udm::AssocAttr<IIF::EventDependencyTimeStamp> eventtimestamps() const { return Udm::AssocAttr<IIF::EventDependencyTimeStamp>(impl, meta_eventtimestamps); }

		static Uml::AssociationRole meta_SuppliedEventTimeStamp;
		Udm::AssocAttr<IIF::SuppliedEventTimeStamp> SuppliedEventTimeStamp() const { return Udm::AssocAttr<IIF::SuppliedEventTimeStamp>(impl, meta_SuppliedEventTimeStamp); }

		static Uml::AssociationRole meta_ConsumedEventTimeStamp;
		Udm::AssocAttr<IIF::ConsumedEventTimeStamp> ConsumedEventTimeStamp() const { return Udm::AssocAttr<IIF::ConsumedEventTimeStamp>(impl, meta_ConsumedEventTimeStamp); }

		static Uml::CompositionParentRole meta_PublishPort_parent;
		Udm::ParentAttr<IIF::PublishPort> PublishPort_parent() const { return Udm::ParentAttr<IIF::PublishPort>(impl, meta_PublishPort_parent); }

		Udm::ParentAttr<IIF::IIFObject> parent() const { return Udm::ParentAttr<IIF::IIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class Action :  public IIFObject {
	 public:
		static Uml::Class meta;

		Action() { }
		Action(Udm::ObjectImpl *impl) : IIFObject(impl) { }
		Action(const Action &master) : IIFObject(master) { }
		static Action Cast(const Object &a) { return __Cast(a, meta); }

		static Action Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::AssociationRole meta_RemoteMethodTimeStamp;
		Udm::AssocAttr<IIF::RemoteMethodTimeStamp> RemoteMethodTimeStamp() const { return Udm::AssocAttr<IIF::RemoteMethodTimeStamp>(impl, meta_RemoteMethodTimeStamp); }

		static Uml::CompositionParentRole meta_Component_parent;
		Udm::ParentAttr<IIF::Component> Component_parent() const { return Udm::ParentAttr<IIF::Component>(impl, meta_Component_parent); }

		Udm::ParentAttr<IIF::IIFObject> parent() const { return Udm::ParentAttr<IIF::IIFObject>(impl, Udm::NULLPARENTROLE); }
	};

	class ComponentMode :  public Object {
	 public:
		static Uml::Class meta;

		ComponentMode() { }
		ComponentMode(Udm::ObjectImpl *impl) : Object(impl) { }
		ComponentMode(const ComponentMode &master) : Object(master) { }
		static ComponentMode Cast(const Object &a) { return __Cast(a, meta); }

		static ComponentMode Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_mode;
		Udm::StringAttr mode() const { return Udm::StringAttr(impl, meta_mode); }

		static Uml::AssociationRole meta_Component;
		Udm::PointerAttr<IIF::Component> Component() const { return Udm::PointerAttr<IIF::Component>(impl, meta_Component); }

		static Uml::CompositionParentRole meta_frameModes_ModeTimeStamp_parent;
		Udm::ParentAttr<IIF::ModeTimeStamp> frameModes_ModeTimeStamp_parent() const { return Udm::ParentAttr<IIF::ModeTimeStamp>(impl, meta_frameModes_ModeTimeStamp_parent); }

		Udm::ParentAttr<IIF::Timestamp> parent() const { return Udm::ParentAttr<IIF::Timestamp>(impl, Udm::NULLPARENTROLE); }
	};

	class Timestamp :  public Object {
	 public:
		static Uml::Class meta;

		Timestamp() { }
		Timestamp(Udm::ObjectImpl *impl) : Object(impl) { }
		Timestamp(const Timestamp &master) : Object(master) { }
		static Timestamp Cast(const Object &a) { return __Cast(a, meta); }

		static Timestamp Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_timestamp;
		Udm::IntegerAttr timestamp() const { return Udm::IntegerAttr(impl, meta_timestamp); }

		static Uml::CompositionParentRole meta_System_parent;
		Udm::ParentAttr<IIF::System> System_parent() const { return Udm::ParentAttr<IIF::System>(impl, meta_System_parent); }

		Udm::ParentAttr<IIF::System> parent() const { return Udm::ParentAttr<IIF::System>(impl, Udm::NULLPARENTROLE); }
	};

	class PreemptionTimeStamp :  public Timestamp {
	 public:
		static Uml::Class meta;

		PreemptionTimeStamp() { }
		PreemptionTimeStamp(Udm::ObjectImpl *impl) : Timestamp(impl) { }
		PreemptionTimeStamp(const PreemptionTimeStamp &master) : Timestamp(master) { }
		static PreemptionTimeStamp Cast(const Object &a) { return __Cast(a, meta); }

		static PreemptionTimeStamp Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_type;
		Udm::IntegerAttr type() const { return Udm::IntegerAttr(impl, meta_type); }

		static Uml::AssociationRole meta_Thread;
		Udm::PointerAttr<IIF::Thread> Thread() const { return Udm::PointerAttr<IIF::Thread>(impl, meta_Thread); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class QueueReorderingTimeStamp :  public Timestamp {
	 public:
		static Uml::Class meta;

		QueueReorderingTimeStamp() { }
		QueueReorderingTimeStamp(Udm::ObjectImpl *impl) : Timestamp(impl) { }
		QueueReorderingTimeStamp(const QueueReorderingTimeStamp &master) : Timestamp(master) { }
		static QueueReorderingTimeStamp Cast(const Object &a) { return __Cast(a, meta); }

		static QueueReorderingTimeStamp Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_type;
		Udm::IntegerAttr type() const { return Udm::IntegerAttr(impl, meta_type); }

		static Uml::AssociationRole meta_DispatchingQueue;
		Udm::PointerAttr<IIF::DispatchingQueue> DispatchingQueue() const { return Udm::PointerAttr<IIF::DispatchingQueue>(impl, meta_DispatchingQueue); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class FrameTimeStamp :  public Timestamp {
	 public:
		static Uml::Class meta;

		FrameTimeStamp() { }
		FrameTimeStamp(Udm::ObjectImpl *impl) : Timestamp(impl) { }
		FrameTimeStamp(const FrameTimeStamp &master) : Timestamp(master) { }
		static FrameTimeStamp Cast(const Object &a) { return __Cast(a, meta); }

		static FrameTimeStamp Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_type;
		Udm::IntegerAttr type() const { return Udm::IntegerAttr(impl, meta_type); }

		static Uml::AssociationRole meta_Rate;
		Udm::PointerAttr<IIF::Rate> Rate() const { return Udm::PointerAttr<IIF::Rate>(impl, meta_Rate); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class ThreadedTimeStamp :  public Timestamp {
	 public:
		static Uml::Class meta;

		ThreadedTimeStamp() { }
		ThreadedTimeStamp(Udm::ObjectImpl *impl) : Timestamp(impl) { }
		ThreadedTimeStamp(const ThreadedTimeStamp &master) : Timestamp(master) { }
		static ThreadedTimeStamp Cast(const Object &a) { return __Cast(a, meta); }

		static ThreadedTimeStamp Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::AssociationRole meta_thread;
		Udm::PointerAttr<IIF::Thread> thread() const { return Udm::PointerAttr<IIF::Thread>(impl, meta_thread); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class EventDependencyTimeStamp :  public ThreadedTimeStamp {
	 public:
		static Uml::Class meta;

		EventDependencyTimeStamp() { }
		EventDependencyTimeStamp(Udm::ObjectImpl *impl) : ThreadedTimeStamp(impl) { }
		EventDependencyTimeStamp(const EventDependencyTimeStamp &master) : ThreadedTimeStamp(master) { }
		static EventDependencyTimeStamp Cast(const Object &a) { return __Cast(a, meta); }

		static EventDependencyTimeStamp Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::AssociationRole meta_SubscribePort;
		Udm::PointerAttr<IIF::SubscribePort> SubscribePort() const { return Udm::PointerAttr<IIF::SubscribePort>(impl, meta_SubscribePort); }

		static Uml::AssociationRole meta_incomingEvent;
		Udm::PointerAttr<IIF::Event> incomingEvent() const { return Udm::PointerAttr<IIF::Event>(impl, meta_incomingEvent); }

		static Uml::AssociationRole meta_outgoingEvents;
		Udm::AssocAttr<IIF::Event> outgoingEvents() const { return Udm::AssocAttr<IIF::Event>(impl, meta_outgoingEvents); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class SuppliedEventTimeStamp :  public ThreadedTimeStamp {
	 public:
		static Uml::Class meta;

		SuppliedEventTimeStamp() { }
		SuppliedEventTimeStamp(Udm::ObjectImpl *impl) : ThreadedTimeStamp(impl) { }
		SuppliedEventTimeStamp(const SuppliedEventTimeStamp &master) : ThreadedTimeStamp(master) { }
		static SuppliedEventTimeStamp Cast(const Object &a) { return __Cast(a, meta); }

		static SuppliedEventTimeStamp Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_type;
		Udm::IntegerAttr type() const { return Udm::IntegerAttr(impl, meta_type); }

		static Uml::AssociationRole meta_PublishPort;
		Udm::PointerAttr<IIF::PublishPort> PublishPort() const { return Udm::PointerAttr<IIF::PublishPort>(impl, meta_PublishPort); }

		static Uml::AssociationRole meta_Event;
		Udm::PointerAttr<IIF::Event> Event() const { return Udm::PointerAttr<IIF::Event>(impl, meta_Event); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class ModeTimeStamp :  public ThreadedTimeStamp {
	 public:
		static Uml::Class meta;

		ModeTimeStamp() { }
		ModeTimeStamp(Udm::ObjectImpl *impl) : ThreadedTimeStamp(impl) { }
		ModeTimeStamp(const ModeTimeStamp &master) : ThreadedTimeStamp(master) { }
		static ModeTimeStamp Cast(const Object &a) { return __Cast(a, meta); }

		static ModeTimeStamp Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::CompositionChildRole meta_frameModes;
		Udm::ChildrenAttr<IIF::ComponentMode> frameModes() const { return Udm::ChildrenAttr<IIF::ComponentMode>(impl, meta_frameModes); }

		Udm::ChildrenAttr<IIF::ComponentMode> ComponentMode_kind_children() const { return Udm::ChildrenAttr<IIF::ComponentMode>(impl, Udm::NULLCHILDROLE); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class ConsumedEventTimeStamp :  public ThreadedTimeStamp {
	 public:
		static Uml::Class meta;

		ConsumedEventTimeStamp() { }
		ConsumedEventTimeStamp(Udm::ObjectImpl *impl) : ThreadedTimeStamp(impl) { }
		ConsumedEventTimeStamp(const ConsumedEventTimeStamp &master) : ThreadedTimeStamp(master) { }
		static ConsumedEventTimeStamp Cast(const Object &a) { return __Cast(a, meta); }

		static ConsumedEventTimeStamp Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_type;
		Udm::IntegerAttr type() const { return Udm::IntegerAttr(impl, meta_type); }

		static Uml::AssociationRole meta_PublishPort;
		Udm::PointerAttr<IIF::PublishPort> PublishPort() const { return Udm::PointerAttr<IIF::PublishPort>(impl, meta_PublishPort); }

		static Uml::AssociationRole meta_SubscribePort;
		Udm::PointerAttr<IIF::SubscribePort> SubscribePort() const { return Udm::PointerAttr<IIF::SubscribePort>(impl, meta_SubscribePort); }

		static Uml::AssociationRole meta_Event;
		Udm::PointerAttr<IIF::Event> Event() const { return Udm::PointerAttr<IIF::Event>(impl, meta_Event); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class RemoteMethodTimeStamp :  public ThreadedTimeStamp {
	 public:
		static Uml::Class meta;

		RemoteMethodTimeStamp() { }
		RemoteMethodTimeStamp(Udm::ObjectImpl *impl) : ThreadedTimeStamp(impl) { }
		RemoteMethodTimeStamp(const RemoteMethodTimeStamp &master) : ThreadedTimeStamp(master) { }
		static RemoteMethodTimeStamp Cast(const Object &a) { return __Cast(a, meta); }

		static RemoteMethodTimeStamp Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_type;
		Udm::IntegerAttr type() const { return Udm::IntegerAttr(impl, meta_type); }

		static Uml::AssociationRole meta_Action;
		Udm::PointerAttr<IIF::Action> Action() const { return Udm::PointerAttr<IIF::Action>(impl, meta_Action); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

}

#endif //MOBIES_IIF_H
