#ifndef MOBIES_LAMPDIAGRAM_H
#define MOBIES_LAMPDIAGRAM_H
// header file LampDiagram.h generated from diagram LampDiagram
// generated on Wed Nov 13 20:41:50 2002

#ifndef MOBIES_UDMBASE_H
#include "UdmBase.h"
#endif

namespace LampDiagram {

	typedef Udm::Object Object;

	class RootFolder;
	class Switch;
	class Lamp;
	class Bulb;
	class ElectricTerminal;
	class ElectricDevice;
	class HalogenBulb;
	class Plug;
	class Wire;
	class ControlLink;

	void Initialize();
	extern Udm::UdmDiagram diagram;

	class RootFolder :  public Object {
	 public:
		static Uml::Class meta;

		RootFolder() { }
		RootFolder(Udm::ObjectImpl *impl) : Object(impl) { }
		RootFolder(const RootFolder &master) : Object(master) { }
		static RootFolder Cast(const Object &a) { return __Cast(a, meta); }

		static RootFolder Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::CompositionChildRole meta_ElectricDevice_children;
		Udm::ChildrenAttr<LampDiagram::ElectricDevice> ElectricDevice_children() const { return Udm::ChildrenAttr<LampDiagram::ElectricDevice>(impl, meta_ElectricDevice_children); }

		Udm::ChildrenAttr<LampDiagram::Switch> Switch_kind_children() const { return Udm::ChildrenAttr<LampDiagram::Switch>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<LampDiagram::Lamp> Lamp_kind_children() const { return Udm::ChildrenAttr<LampDiagram::Lamp>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<LampDiagram::Bulb> Bulb_kind_children() const { return Udm::ChildrenAttr<LampDiagram::Bulb>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<LampDiagram::ElectricDevice> ElectricDevice_kind_children() const { return Udm::ChildrenAttr<LampDiagram::ElectricDevice>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<LampDiagram::HalogenBulb> HalogenBulb_kind_children() const { return Udm::ChildrenAttr<LampDiagram::HalogenBulb>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<LampDiagram::Plug> Plug_kind_children() const { return Udm::ChildrenAttr<LampDiagram::Plug>(impl, Udm::NULLCHILDROLE); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class ElectricTerminal :  public Object {
	 public:
		static Uml::Class meta;

		ElectricTerminal() { }
		ElectricTerminal(Udm::ObjectImpl *impl) : Object(impl) { }
		ElectricTerminal(const ElectricTerminal &master) : Object(master) { }
		static ElectricTerminal Cast(const Object &a) { return __Cast(a, meta); }

		static ElectricTerminal Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_position;
		Udm::StringAttr position() const { return Udm::StringAttr(impl, meta_position); }

		static Uml::Attribute meta_Type;
		Udm::StringAttr Type() const { return Udm::StringAttr(impl, meta_Type); }

		static Uml::AssociationRole meta_End1, meta_End1_rev;
		Udm::AClassAssocAttr<LampDiagram::Wire, LampDiagram::ElectricTerminal> End1() const { return Udm::AClassAssocAttr<LampDiagram::Wire, LampDiagram::ElectricTerminal>(impl, meta_End1, meta_End1_rev); }

		static Uml::AssociationRole meta_End2, meta_End2_rev;
		Udm::AClassAssocAttr<LampDiagram::Wire, LampDiagram::ElectricTerminal> End2() const { return Udm::AClassAssocAttr<LampDiagram::Wire, LampDiagram::ElectricTerminal>(impl, meta_End2, meta_End2_rev); }

		static Uml::CompositionParentRole meta_ElectricDevice_parent;
		Udm::ParentAttr<LampDiagram::ElectricDevice> ElectricDevice_parent() const { return Udm::ParentAttr<LampDiagram::ElectricDevice>(impl, meta_ElectricDevice_parent); }

		Udm::ParentAttr<LampDiagram::ElectricDevice> parent() const { return Udm::ParentAttr<LampDiagram::ElectricDevice>(impl, Udm::NULLPARENTROLE); }
	};

	class ElectricDevice :  public Object {
	 public:
		static Uml::Class meta;

		ElectricDevice() { }
		ElectricDevice(Udm::ObjectImpl *impl) : Object(impl) { }
		ElectricDevice(const ElectricDevice &master) : Object(master) { }
		static ElectricDevice Cast(const Object &a) { return __Cast(a, meta); }

		static ElectricDevice Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_MaxTempRating;
		Udm::IntegerAttr MaxTempRating() const { return Udm::IntegerAttr(impl, meta_MaxTempRating); }

		static Uml::Attribute meta_MaxVoltageRating;
		Udm::RealAttr MaxVoltageRating() const { return Udm::RealAttr(impl, meta_MaxVoltageRating); }

		static Uml::Attribute meta_position;
		Udm::StringAttr position() const { return Udm::StringAttr(impl, meta_position); }

		static Uml::Attribute meta_name;
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }

		static Uml::CompositionChildRole meta_ElectricTerminal_children;
		Udm::ChildrenAttr<LampDiagram::ElectricTerminal> ElectricTerminal_children() const { return Udm::ChildrenAttr<LampDiagram::ElectricTerminal>(impl, meta_ElectricTerminal_children); }

		static Uml::CompositionChildRole meta_Wire_children;
		Udm::ChildrenAttr<LampDiagram::Wire> Wire_children() const { return Udm::ChildrenAttr<LampDiagram::Wire>(impl, meta_Wire_children); }

		Udm::ChildrenAttr<LampDiagram::ElectricTerminal> ElectricTerminal_kind_children() const { return Udm::ChildrenAttr<LampDiagram::ElectricTerminal>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<LampDiagram::Wire> Wire_kind_children() const { return Udm::ChildrenAttr<LampDiagram::Wire>(impl, Udm::NULLCHILDROLE); }

		static Uml::CompositionParentRole meta_RootFolder_parent;
		Udm::ParentAttr<LampDiagram::RootFolder> RootFolder_parent() const { return Udm::ParentAttr<LampDiagram::RootFolder>(impl, meta_RootFolder_parent); }

		Udm::ParentAttr<LampDiagram::RootFolder> parent() const { return Udm::ParentAttr<LampDiagram::RootFolder>(impl, Udm::NULLPARENTROLE); }
	};

	class Switch :  public ElectricDevice {
	 public:
		static Uml::Class meta;

		Switch() { }
		Switch(Udm::ObjectImpl *impl) : ElectricDevice(impl) { }
		Switch(const Switch &master) : ElectricDevice(master) { }
		static Switch Cast(const Object &a) { return __Cast(a, meta); }

		static Switch Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_Safe;
		Udm::BooleanAttr Safe() const { return Udm::BooleanAttr(impl, meta_Safe); }

		static Uml::Attribute meta_Amps;
		Udm::RealAttr Amps() const { return Udm::RealAttr(impl, meta_Amps); }

		static Uml::AssociationRole meta_src, meta_src_rev;
		Udm::AClassAssocAttr<LampDiagram::ControlLink, LampDiagram::Bulb> src() const { return Udm::AClassAssocAttr<LampDiagram::ControlLink, LampDiagram::Bulb>(impl, meta_src, meta_src_rev); }

		static Uml::CompositionParentRole meta_FunctionSwitch_Lamp_parent;
		Udm::ParentAttr<LampDiagram::Lamp> FunctionSwitch_Lamp_parent() const { return Udm::ParentAttr<LampDiagram::Lamp>(impl, meta_FunctionSwitch_Lamp_parent); }

		static Uml::CompositionParentRole meta_MainSwitch_Lamp_parent;
		Udm::ParentAttr<LampDiagram::Lamp> MainSwitch_Lamp_parent() const { return Udm::ParentAttr<LampDiagram::Lamp>(impl, meta_MainSwitch_Lamp_parent); }

		Udm::ParentAttr<LampDiagram::ElectricDevice> parent() const { return Udm::ParentAttr<LampDiagram::ElectricDevice>(impl, Udm::NULLPARENTROLE); }
	};

	class Lamp :  public ElectricDevice {
	 public:
		static Uml::Class meta;

		Lamp() { }
		Lamp(Udm::ObjectImpl *impl) : ElectricDevice(impl) { }
		Lamp(const Lamp &master) : ElectricDevice(master) { }
		static Lamp Cast(const Object &a) { return __Cast(a, meta); }

		static Lamp Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_ArrayStr;
		Udm::StringAttrArr ArrayStr() const { return Udm::StringAttrArr(impl, meta_ArrayStr); }

		static Uml::Attribute meta_ModelName;
		Udm::StringAttr ModelName() const { return Udm::StringAttr(impl, meta_ModelName); }

		static Uml::Attribute meta_ArrayInt;
		Udm::IntegerAttrArr ArrayInt() const { return Udm::IntegerAttrArr(impl, meta_ArrayInt); }

		static Uml::Attribute meta_ArrayBool;
		Udm::BooleanAttrArr ArrayBool() const { return Udm::BooleanAttrArr(impl, meta_ArrayBool); }

		static Uml::Attribute meta_ArrayReal;
		Udm::RealAttrArr ArrayReal() const { return Udm::RealAttrArr(impl, meta_ArrayReal); }

		static Uml::Attribute meta_TempArrayStr;
		Udm::TempStringAttrArr TempArrayStr() const { return Udm::TempStringAttrArr(impl, meta_TempArrayStr); }

		static Uml::Attribute meta_TempArrayInt;
		Udm::TempIntegerAttrArr TempArrayInt() const { return Udm::TempIntegerAttrArr(impl, meta_TempArrayInt); }

		static Uml::Attribute meta_TempArrayReal;
		Udm::TempRealAttrArr TempArrayReal() const { return Udm::TempRealAttrArr(impl, meta_TempArrayReal); }

		static Uml::Attribute meta_TempArrayBoolean;
		Udm::TempBooleanAttrArr TempArrayBoolean() const { return Udm::TempBooleanAttrArr(impl, meta_TempArrayBoolean); }

		static Uml::CompositionChildRole meta_MainSwitch;
		Udm::ChildAttr<LampDiagram::Switch> MainSwitch() const { return Udm::ChildAttr<LampDiagram::Switch>(impl, meta_MainSwitch); }

		static Uml::CompositionChildRole meta_ControlLink_children;
		Udm::ChildrenAttr<LampDiagram::ControlLink> ControlLink_children() const { return Udm::ChildrenAttr<LampDiagram::ControlLink>(impl, meta_ControlLink_children); }

		static Uml::CompositionChildRole meta_Bulb_children;
		Udm::ChildrenAttr<LampDiagram::Bulb> Bulb_children() const { return Udm::ChildrenAttr<LampDiagram::Bulb>(impl, meta_Bulb_children); }

		static Uml::CompositionChildRole meta_FunctionSwitch;
		Udm::ChildrenAttr<LampDiagram::Switch> FunctionSwitch() const { return Udm::ChildrenAttr<LampDiagram::Switch>(impl, meta_FunctionSwitch); }

		static Uml::CompositionChildRole meta_Plug_child;
		Udm::ChildAttr<LampDiagram::Plug> Plug_child() const { return Udm::ChildAttr<LampDiagram::Plug>(impl, meta_Plug_child); }

		Udm::ChildrenAttr<LampDiagram::Switch> Switch_kind_children() const { return Udm::ChildrenAttr<LampDiagram::Switch>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<LampDiagram::Bulb> Bulb_kind_children() const { return Udm::ChildrenAttr<LampDiagram::Bulb>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<LampDiagram::ElectricDevice> ElectricDevice_kind_children() const { return Udm::ChildrenAttr<LampDiagram::ElectricDevice>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<LampDiagram::HalogenBulb> HalogenBulb_kind_children() const { return Udm::ChildrenAttr<LampDiagram::HalogenBulb>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<LampDiagram::Plug> Plug_kind_children() const { return Udm::ChildrenAttr<LampDiagram::Plug>(impl, Udm::NULLCHILDROLE); }

		Udm::ChildrenAttr<LampDiagram::ControlLink> ControlLink_kind_children() const { return Udm::ChildrenAttr<LampDiagram::ControlLink>(impl, Udm::NULLCHILDROLE); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class Bulb :  public ElectricDevice {
	 public:
		static Uml::Class meta;

		Bulb() { }
		Bulb(Udm::ObjectImpl *impl) : ElectricDevice(impl) { }
		Bulb(const Bulb &master) : ElectricDevice(master) { }
		static Bulb Cast(const Object &a) { return __Cast(a, meta); }

		static Bulb Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_Wattage;
		Udm::RealAttr Wattage() const { return Udm::RealAttr(impl, meta_Wattage); }

		static Uml::Attribute meta_Voltage;
		Udm::RealAttr Voltage() const { return Udm::RealAttr(impl, meta_Voltage); }

		static Uml::AssociationRole meta_dst, meta_dst_rev;
		Udm::AClassAssocAttr<LampDiagram::ControlLink, LampDiagram::Switch> dst() const { return Udm::AClassAssocAttr<LampDiagram::ControlLink, LampDiagram::Switch>(impl, meta_dst, meta_dst_rev); }

		static Uml::CompositionParentRole meta_Lamp_parent;
		Udm::ParentAttr<LampDiagram::Lamp> Lamp_parent() const { return Udm::ParentAttr<LampDiagram::Lamp>(impl, meta_Lamp_parent); }

		Udm::ParentAttr<LampDiagram::ElectricDevice> parent() const { return Udm::ParentAttr<LampDiagram::ElectricDevice>(impl, Udm::NULLPARENTROLE); }
	};

	class HalogenBulb :  public Bulb {
	 public:
		static Uml::Class meta;

		HalogenBulb() { }
		HalogenBulb(Udm::ObjectImpl *impl) : Bulb(impl) { }
		HalogenBulb(const HalogenBulb &master) : Bulb(master) { }
		static HalogenBulb Cast(const Object &a) { return __Cast(a, meta); }

		static HalogenBulb Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		Udm::ParentAttr<Udm::Object> parent() const { return Udm::ParentAttr<Udm::Object>(impl, Udm::NULLPARENTROLE); }
	};

	class Plug :  public ElectricDevice {
	 public:
		static Uml::Class meta;

		Plug() { }
		Plug(Udm::ObjectImpl *impl) : ElectricDevice(impl) { }
		Plug(const Plug &master) : ElectricDevice(master) { }
		static Plug Cast(const Object &a) { return __Cast(a, meta); }

		static Plug Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_Format;
		Udm::StringAttr Format() const { return Udm::StringAttr(impl, meta_Format); }

		static Uml::CompositionParentRole meta_Lamp_parent;
		Udm::ParentAttr<LampDiagram::Lamp> Lamp_parent() const { return Udm::ParentAttr<LampDiagram::Lamp>(impl, meta_Lamp_parent); }

		Udm::ParentAttr<LampDiagram::ElectricDevice> parent() const { return Udm::ParentAttr<LampDiagram::ElectricDevice>(impl, Udm::NULLPARENTROLE); }
	};

	class Wire :  public Object {
	 public:
		static Uml::Class meta;

		Wire() { }
		Wire(Udm::ObjectImpl *impl) : Object(impl) { }
		Wire(const Wire &master) : Object(master) { }
		static Wire Cast(const Object &a) { return __Cast(a, meta); }

		static Wire Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_Amps;
		Udm::RealAttr Amps() const { return Udm::RealAttr(impl, meta_Amps); }

		static Uml::CompositionParentRole meta_ElectricDevice_parent;
		Udm::ParentAttr<LampDiagram::ElectricDevice> ElectricDevice_parent() const { return Udm::ParentAttr<LampDiagram::ElectricDevice>(impl, meta_ElectricDevice_parent); }

		Udm::ParentAttr<LampDiagram::ElectricDevice> parent() const { return Udm::ParentAttr<LampDiagram::ElectricDevice>(impl, Udm::NULLPARENTROLE); }
		static Uml::AssociationRole meta_End2_end_;
		Udm::AssocEndAttr<LampDiagram::ElectricTerminal> End2_end() const { return Udm::AssocEndAttr<LampDiagram::ElectricTerminal>(impl, meta_End2_end_); }

		static Uml::AssociationRole meta_End1_end_;
		Udm::AssocEndAttr<LampDiagram::ElectricTerminal> End1_end() const { return Udm::AssocEndAttr<LampDiagram::ElectricTerminal>(impl, meta_End1_end_); }

	};

	class ControlLink :  public Object {
	 public:
		static Uml::Class meta;

		ControlLink() { }
		ControlLink(Udm::ObjectImpl *impl) : Object(impl) { }
		ControlLink(const ControlLink &master) : Object(master) { }
		static ControlLink Cast(const Object &a) { return __Cast(a, meta); }

		static ControlLink Create(const Object &parent, const Uml::CompositionChildRole &role = Udm::NULLCHILDROLE) { return __Create(meta, parent, role); }

		static Uml::Attribute meta_name;
		Udm::StringAttr name() const { return Udm::StringAttr(impl, meta_name); }

		static Uml::CompositionParentRole meta_Lamp_parent;
		Udm::ParentAttr<LampDiagram::Lamp> Lamp_parent() const { return Udm::ParentAttr<LampDiagram::Lamp>(impl, meta_Lamp_parent); }

		Udm::ParentAttr<LampDiagram::ElectricDevice> parent() const { return Udm::ParentAttr<LampDiagram::ElectricDevice>(impl, Udm::NULLPARENTROLE); }
		static Uml::AssociationRole meta_dst_end_;
		Udm::AssocEndAttr<LampDiagram::Switch> dst_end() const { return Udm::AssocEndAttr<LampDiagram::Switch>(impl, meta_dst_end_); }

		static Uml::AssociationRole meta_src_end_;
		Udm::AssocEndAttr<LampDiagram::Bulb> src_end() const { return Udm::AssocEndAttr<LampDiagram::Bulb>(impl, meta_src_end_); }

	};

}

#endif //MOBIES_LAMPDIAGRAM_H
