#include "stdafx.h"
#include "AIFRead.h"
#include "RMA.h"
#include <math.h>


#if 0
void CSystem::ComputeUtilizations() {

	POSITION pos = processorNodeList.GetHeadPosition();
	while(pos) {
		CProcessorNode *processorNode = processorNodeList.GetNext(pos);
		processorNode->utilization = 0.0;
		double maxBlocking = 0.0;
		int numTasks = 0;
		POSITION pos2 = processorNode->taskNodeList.GetHeadPosition();
		while(pos2) {
			CTaskNode *taskNode = processorNode->taskNodeList.GetNext(pos2);
			processorNode->utilization += taskNode->wcet / taskNode->period;
			numTasks++;
			if(taskNode->blockingTime / taskNode->period > maxBlocking) {
				maxBlocking = taskNode->blockingTime / taskNode->period;
			}
		}
		//Should I add the maxBlocking term? Since I put task wcets of equal priority
		//into a task's blocking time, it may not fit the original model.
		//processorNode->utilization += maxBlocking;
		processorNode->utilizationBound = numTasks * (pow(2.0, 1.0/numTasks) - 1);
	}

}
#endif
/*
static double Inteference(CTaskNode **taskArray, int index, double responseTime, double cxtSwitchTime) {
	int j = 0;
	double sum = 0;
	for(j = 0; j < index; j++) {
		sum += ceil((taskArray[j]->releaseJitter + responseTime)/taskArray[j]->period) *
			(taskArray[j]->wcet + 2 * cxtSwitchTime);
	}
	return sum;
}


static double Pj(CTaskNode **taskArray, int j, double Pj, double cxtSwitchTime) {
	int i = 0;
	double sum = 0;

	for(i = 0; i < j; i++) {
		sum += ceil(Pj/taskArray[i]->period) *
			(taskArray[i]->wcet + (i == 0 ? 2 : 0) * cxtSwitchTime);
	}
	return sum;
}

static double BestCaseInteference(CTaskNode **taskArray, int index, double responseTime, double cxtSwitchTime) {
	int j = 0;
	double sum = 0;

	for(j = 0; j < index; j++) {
		sum += ceil((responseTime - taskArray[j]->releaseJitter + taskArray[j]->Pj)/taskArray[j]->period - 1) *
			(taskArray[j]->wcet + (j == 0 ? 2 : 0) * cxtSwitchTime);
	}
	return sum;
}
*/
static double Inteference(const CProcessorNode *pNode, const CTaskNode *tNode, double responseTime) {
#if 0
	double sum = 0;
	POSITION pos = pNode->taskNodeList.GetHeadPosition();
	while(pos) {
		CTaskNode *tNode2 = pNode->taskNodeList.GetNext(pos);
		if(tNode == tNode2) continue;
		if(tNode2->priority > tNode->priority) {
			sum += ceil((tNode2->releaseJitter + responseTime)/tNode2->period) *
			(tNode2->wcet + 2 * pNode->cxtSwitchTime);
		}
	}
	return sum;
#endif
}

static double Pj(const CProcessorNode *pNode, const CTaskNode *tNode, double Pj) {

	double sum = 0;
#if 0
	CTaskNode *maxPriorityTask = pNode->taskNodeList.GetHead();
	ASSERT(maxPriorityTask);

	POSITION pos = pNode->taskNodeList.GetHeadPosition();
	while(pos) {
		CTaskNode *tNode2 = pNode->taskNodeList.GetNext(pos);
		if(tNode2->priority > maxPriorityTask->priority) {
			maxPriorityTask = tNode2;
		}
	}

	pos = pNode->taskNodeList.GetHeadPosition();
	while(pos) {
		CTaskNode *tNode2 = pNode->taskNodeList.GetNext(pos);
		if(tNode == tNode2) continue;
		if(tNode2->priority > tNode->priority) {
			sum += ceil(Pj/tNode2->period) *
			(tNode2->wcet + (tNode2 == maxPriorityTask ? 2 : 0) * pNode->cxtSwitchTime);
		}
	}
#endif
	return sum;
}

static double BestCaseInteference(const CProcessorNode *pNode, const CTaskNode *tNode, double responseTime) {
	return 0;
#if 0
	double sum = 0;
	CTaskNode *maxPriorityTask = pNode->taskNodeList.GetHead();
	ASSERT(maxPriorityTask);

	POSITION pos = pNode->taskNodeList.GetHeadPosition();
	while(pos) {
		CTaskNode *tNode2 = pNode->taskNodeList.GetNext(pos);
		if(tNode2->priority > maxPriorityTask->priority) {
			maxPriorityTask = tNode2;
		}
	}

	pos = pNode->taskNodeList.GetHeadPosition();
	while(pos) {
		CTaskNode *tNode2 = pNode->taskNodeList.GetNext(pos);
		if(tNode == tNode2) continue;
		if(tNode2->priority > tNode->priority) {
			sum += ceil((responseTime - tNode2->releaseJitter + tNode2->Pj)/tNode2->period - 1) *
				(tNode2->wcet + (tNode2 == maxPriorityTask ? 2 : 0) * pNode->cxtSwitchTime);
		}
	}

	return sum;
#endif
}
#define SMALL_STEP 0.05
//#define BIG_NUMBER 9999999.0
//The classic RMA response time computation. Ccs is CPU context switch time.
//ri = Ci + 2Ccs + Sum(hp(i)) (ceil((ri + Jj)/Tj) * (Cj + 2Ccs))
#if 0
bool CSystem::ProcessorAnalysis() {

	bool ret = true;
	POSITION pos = processorNodeList.GetHeadPosition();
	while(pos) {
		CProcessorNode *pNode = processorNodeList.GetNext(pos);
		if(!SingleProcessorAnalysis(pNode)) {
			ret = false;
		}
		//Put it in SingleProcessorAnalysis
		//pNode->CalcReserveProfileTable();
	}
	return ret;

	return true;
}
#endif

#if 0
void CProcessorNode::CalcReserveProfileTable() {

	int numTasks = taskNodeList.GetCount();
	CTaskNode **ta = new CTaskNode *[numTasks];
	int temp = 0;
	POSITION pos = taskNodeList.GetHeadPosition();
	while(pos) {
		ta[temp++] = taskNodeList.GetNext(pos);
	}
	
	for(int x = 0; x < numTasks; x++) {
		for(int i = 0; i < numTasks; i++) {
			reserveProfileTable[x][i] = 0.0;
		}
	}

	for(x = 0; x < numTasks; x++) {
		for(int i = x; i < numTasks; i++) {
			//Hack
			/*
			double P1 = BIG_NUMBER;
			
			for(int j = 0; j <= i; j++) {
				P1 = MIN(P1, ceil(ta[i]->localWcrt/ta[j]->period)*ta[j]->period);
			}
						
			double Sx1 = (MIN(P1, ta[i]->deadline) - ta[i]->localWcrt)
				/ceil(ta[i]->localWcrt/ta[x]->period);*/
			if(ta[i]->localWcrt < 0.001) {
				reserveProfileTable[x][i] = 1.0 - utilization;
			} else {
				double Sx1 = (ta[i]->deadline - ta[i]->localWcrt)
					/ceil(ta[i]->localWcrt/ta[x]->period);
				reserveProfileTable[x][i] = Sx1/ta[x]->period;
			}
		}
	}

}
#endif
#if 0
bool CSystem::SingleProcessorAnalysis(CProcessorNode *pNode) {

	bool ret = true;
	POSITION pos = pNode->taskNodeList.GetHeadPosition();
	while(pos) {
		CTaskNode *task = pNode->taskNodeList.GetNext(pos);
		double oldP, P;
		oldP = P = 0;
		P = task->wcet + Pj(pNode, task, oldP);
		while(fabs(oldP - P) > SMALL_STEP) {
			oldP = P;
			P = task->wcet + Pj(pNode, task, oldP);
			if(P > CONVERGENCE_LIMIT) {
				CString cs;
				cs.Format("Pj computation for task %s on processor %d failed to converge! oldP:%.2lf, P:%.2lf",
					task->name, pNode->id, oldP, P);
				//AfxMessageBox(cs);
				//return false;
				ret = false;
				P = BIG_NUMBER;
				break;
			}
		}
		task->Pj = P;
	}

	POSITION pos2 = pNode->taskNodeList.GetHeadPosition();
	while(pos2) {
		CTaskNode *task = pNode->taskNodeList.GetNext(pos2);
		double oldr, r;
		oldr = r = 0;
		r = task->wcet + task->blockingTime + 2 * pNode->cxtSwitchTime +
			Inteference(pNode, task, oldr);
		while(fabs(oldr - r) > SMALL_STEP) {
			oldr = r;
			r = task->wcet + task->blockingTime + 2 * pNode->cxtSwitchTime +
				Inteference(pNode, task, oldr);
			if(r> CONVERGENCE_LIMIT) {
				CString cs;
				cs.Format("Response time analysis for task %s on processor %d failed to converge!, oldr: %.2lf, r:%.2lf",
					task->name, pNode->id, oldr, r);
				//AfxMessageBox(cs);
				ret = false;
				r = CONVERGENCE_LIMIT;
				break;
				//return false;
			}
		}
		task->localWcrt = r;
		//Hack:
		if(task->period == BIG_NUMBER) {
			task->wcrt = task->localWcrt;
		}
#if 1
		double oldbr, br;
		oldbr = 0;
		br = task->wcet + BestCaseInteference(pNode, task, oldbr);
		while(fabs(oldbr - br) > SMALL_STEP) {
			oldbr = br;
			br = task->wcet + BestCaseInteference(pNode, task, oldbr);
			if(br> CONVERGENCE_LIMIT) {
				CString cs;
				cs.Format("Best case response time analysis for task %s on processor %d failed to converge! oldbr: %.2lf, br %.2lf",
					task->name, pNode->id, oldbr, br);
					
				//AfxMessageBox(cs);
				//DebugDisplayTaskNodeList();
				ret = false;
				br = CONVERGENCE_LIMIT;
				//return false;
				break;
			}
		}
		task->localBcrt = br;
		if(task->period == BIG_NUMBER) {
			task->bcrt = task->localBcrt;
		}
#endif
//		task->localBcrt = 0;
	}
	return ret;

	return true;
}
#endif

#if 0
bool CSystem::HolisticAnalysis() {

	int iter = 0;
	bool converged = false;
	bool systemConverged = true;

	POSITION pos = taskNodeList.GetHeadPosition();
	while(pos) {
		CTaskNode *tNode = taskNodeList.GetNext(pos);
		tNode->Reset();
	}

	while(!converged) {
		//If any of the processor analysis did not converge, then give up.
		if(!ProcessorAnalysis()) {
			systemConverged = false;
			break;
		}

		//If all processor analysis did converge, even though the system may not be
		//schedulable, push on and compute e2e timing.
		converged = true;

		//update the wcrt/bcrt/releaseJitter of each task
		POSITION pos = taskChainList.GetHeadPosition();
		while(pos) {
			CTaskChain *tChain = taskChainList.GetNext(pos);
			
			CTaskNode *tNodeHead = tChain->taskNodeList.GetHead();
			tNodeHead->wcrt = MAX(tNodeHead->wcrt, tNodeHead->localWcrt);
			tNodeHead->bcrt = MIN(tNodeHead->bcrt, tNodeHead->localBcrt);
			POSITION pos2 = tChain->taskNodeList.GetHeadPosition();
			while(pos2) {
				CTaskNode *tNode = tChain->taskNodeList.GetNext(pos2);
				if(pos2) {
					CTaskNode *tNodeNext = tChain->taskNodeList.GetAt(pos2);
					ASSERT(tNodeNext->wcrt <= tNode->wcrt + tNodeNext->localWcrt);
					ASSERT(tNodeNext->bcrt >= tNode->bcrt + tNodeNext->localBcrt);
					ASSERT(tNodeNext->releaseJitter <= tNode->wcrt - tNode->bcrt);
					tNodeNext->wcrt = MAX(tNodeNext->wcrt, tNode->wcrt + tNodeNext->localWcrt);
					tNodeNext->bcrt = MIN(tNodeNext->bcrt, tNode->bcrt + tNodeNext->localBcrt);
					tNodeNext->releaseJitter = MAX(tNodeNext->releaseJitter, tNode->wcrt - tNode->bcrt);
				}
			}
		}
		
		pos = taskChainList.GetHeadPosition();
		while(pos) {
			CTaskChain *tChain = taskChainList.GetNext(pos);
			CTaskNode *tNodeTail = tChain->taskNodeList.GetTail();
			if(fabs(tNodeTail->previousWcrt - tNodeTail->wcrt) > 1.0 ||
				fabs(tNodeTail->previousBcrt - tNodeTail->bcrt) > 1.0) {
				converged = false;
			}
		}

		//if(converged) return true;

		pos = taskNodeList.GetHeadPosition();
		while(pos) {
			CTaskNode *tNode = taskNodeList.GetNext(pos);
			tNode->previousWcrt = tNode->wcrt;
			tNode->previousBcrt = tNode->bcrt;
		}
		
		/*
		tNodeHead->wcrt = MAX(tNodeHead->wcrt, tNodeHead->localWcrt);
		tNodeHead->bcrt = MIN(tNodeHead->bcrt, tNodeHead->localBcrt);
		POSITION pos2 = tChain->taskNodeList.GetHeadPosition();
		while(pos2) {
			
			if(fabs(taskNode->previousWcrt - taskNode->wcrt) > 1.0 ||
				fabs(taskNode->previousBcrt - taskNode->bcrt) > 1.0) {
				converged = false;
			}
			taskNode->previousWcrt = taskNode->wcrt;
			taskNode->previousBcrt = taskNode->bcrt;
			POSITION pos2 = taskNode->adjList.GetHeadPosition();
			while(pos2) {
				CTaskNode *taskNode2 = taskNode->adjList.GetNext(pos2);
				taskNode2->releaseJitter = taskNode->wcrt - taskNode->bcrt;
				taskNode2->wcrt = taskNode->wcrt + taskNode2->localWcrt;
				taskNode2->bcrt = taskNode->bcrt + taskNode2->localBcrt;
			}
			
		}*/
		if(iter++ > 10000) {
			AfxMessageBox("Too many iterations in HolisticAnalysis!");
			systemConverged = false;
			break;
		}
	}

	if(!systemConverged) {
		POSITION pos2 = taskNodeList.GetHeadPosition();
		while(pos2) {
			CTaskNode *tNode = taskNodeList.GetNext(pos2);
			tNode->wcrt = tNode->bcrt = tNode->releaseJitter = BIG_NUMBER;
		}
	}
	//Here the holistic analysis must have converged. Check schedulability by comparing wcrt and deadline.
	bool schedulable = true;
	pos = processorNodeList.GetHeadPosition();
	while(pos) {
		CProcessorNode *pNode = processorNodeList.GetNext(pos);
		POSITION pos2 = pNode->taskNodeList.GetHeadPosition();
		pNode->schedulable = true;
		while(pos2) {
			CTaskNode *tNode = pNode->taskNodeList.GetNext(pos2);
			if(tNode->wcrt > tNode->deadline) {
				pNode->schedulable = false;
				schedulable = false;
			}
		}
	}

	return schedulable;

	return true;
}
#endif

#define MAX_FACTOR 1024.0

#if 0
double CSystem::FindSystemFactorInInterval(double initial, double final) {

	double half = (initial + final)/2.0;
	ScaleSystem(half);
	if(HolisticAnalysis()) {
		if(final - half < SMALL_STEP) {
			return half;
		} else {
			return FindSystemFactorInInterval(half, final);
		}
	} else {
		if(half - initial < SMALL_STEP) {
			return initial;
		} else {
			return FindSystemFactorInInterval(initial, half);
		}
	}

	return 0;
}

#endif

#if 0
double CSystem::CalculateSystemSlack() {

	double initial = 1.0, factor = 1.0;

	//If system is schedulable, scale up the system by 2 until it's not schedulable
	if(HolisticAnalysis()) {
		while(true) {
			initial = factor;
			factor *= 2.0;
			ScaleSystem(factor);
			if(!HolisticAnalysis()) {
				factor = FindSystemFactorInInterval(initial, factor);
				break;
			}
			if(factor >= MAX_FACTOR) break;
		}
	} else {
		ScaleSystem(0.0);
		ASSERT(HolisticAnalysis());
		factor = FindSystemFactorInInterval(0.0, 1.0);
	}

	slack = factor - 1.0;
	return slack;

	return 0;
}
#endif
/*
-- calculates the relative amount that the execution times of the
   -- actions of the transaction referenced by Trans_Ref may grow
   -- (or may need decreasing) for the system to continue
   -- being (or become) schedulable
   -- Ci* = Ci * (1+The_Slack) for all actions in the transaction
*/
#if 0
double CSystem::FindTransactionFactorInInterval(CTaskChain *tChain, double initial, double final) {

	double half = (initial + final)/2.0;
	ScaleTransaction(tChain, half);
	if(HolisticAnalysis()) {
		if(final - half < SMALL_STEP) {
			return half;
		} else {
			return FindTransactionFactorInInterval(tChain, half, final);
		}
	} else {
		if(half - initial < SMALL_STEP) {
			return initial;
		} else {
			return FindTransactionFactorInInterval(tChain, initial, half);
		}
	}

}
#endif
#if 0
double CSystem::CalculateTransactionSlack(CTaskChain *tChain) {

	double initial = 1.0, factor = 1.0;

	//If system is schedulable, scale up the transaction by 2 until it's not schedulable
	if(HolisticAnalysis()) {
		while(true) {
			initial = factor;
			factor *= 2.0;
			ScaleTransaction(tChain, factor);
			if(!HolisticAnalysis()) {
				factor = FindTransactionFactorInInterval(tChain, initial, factor);
				break;
			}
			if(factor > MAX_FACTOR) break;
		}
	} else {
		ScaleTransaction(tChain, 0.0);
		if(HolisticAnalysis()) {
			factor = FindTransactionFactorInInterval(tChain, 0.0, 1.0);
		} else {
			factor = 0.0;
		}
	}

	tChain->slack = factor - 1.0;
	return slack;

	return 0;
}
#endif
///////////////////////////////////////////////////////////////////
//V2V stuff
//////////////////////////////////////////////////////////////////
/*
double CJobChain::InteferenceV2V(double responseTime) {
	double sum = 0.0;
	POSITION pos = gJobChains.GetHeadPosition();
	while(pos) {
		CJobChain *tChain = gJobChains.GetNext(pos);
		if(this == tChain || tChain->type != H) continue;
		ASSERT(tChain->period > 0.0);
		sum += ceil(responseTime/tChain->period) * tChain->totalWCET;
	}
	return sum;
}

bool CJobChain::CalculateResponseTime() {
	//First get the canonical form of the task chain
	for(int i = 0; i < Size(); i++) {
		CJob *job = (*this)[i];
		job->priorityCanonicalForm = job->priority;
	}
	for(i = Size() - 1; i > 0; i--) {
		CJob *job = (*this)[i];
		CJob *jobPrev = (*this)[i-1];
		if(jobPrev->priorityCanonicalForm > job->priorityCanonicalForm) {
			jobPrev->priorityCanonicalForm = job->priorityCanonicalForm;
		}
	}

	for(i = 0; i < Size(); i++) {
		CJob *job = (*this)[i];
		minPriorityCanonicalForm = MIN(job->priority, minPriorityCanonicalForm);
	}

	bool ret = true;
	double B2 = 0.0, B4 = 0.0;
	POSITION pos = gJobChains.GetHeadPosition();
	while(pos) {
		CJobChain *jChain = gJobChains.GetNext(pos);
		if(this == jChain) {
			continue;
		}
		jChain->ClassifyRelativeTo(minPriorityCanonicalForm);
		if(jChain->type == HL || jChain->type == HLH) {
			B2 += jChain->maxHigh;
		}
		if(jChain->type == LH || jChain->type == LHL) {
			B4 = MAX(B4, jChain->maxHigh);
		}
	}

	double oldr, r;
	oldr = r = 0;
	
	r = totalWCET + B2 + B4 + InteferenceV2V(oldr);
	while(fabs(oldr - r) > SMALL_STEP) {
		oldr = r;
		r = totalWCET + B2 + B4 + InteferenceV2V(oldr);
		if(r > BIG_NUMBER) {
			CString cs;
			cs.Format("Response time analysis for job %s failed to converge!, oldr: %.2lf, r:%.2lf",
				name, oldr, r);
			AfxMessageBox(cs);
			ret = false;
			r = BIG_NUMBER;
			break;
		}
	}
	wcrt = r;
	return ret;
}
*/
//A FSM is used to classify a task chain relative to another.
/*			   H            L             H
        H     \/     L     \/       H     \/
INIT -------> INITH --------> L1 -------> H1
                                 <-------
				                    L

			   L           H              L
        L     \/     H     \/       L     \/
INIT -------> INITL --------> H2 -------> L2
								 <-------
								    H
	

If it starts with a L, then it doesn't matter if it ends with a H or L.
If it starts with a H, then it does matter. However for simplicity I treat
HLH the same as HL, i.e., each can contribute a blocking factor.
*/
/*
void CJobChain::ClassifyRelativeTo(int minP) {
	enum {INIT, INITH, L1, H1, INITL, H2, L2} state = INIT;
	maxHigh = 0.0;
	for(int i = 0; i < Size(); i++) {
		CJob *job = (*this)[i];
		bool bHigher = job->priority >= minP;
		switch (state) {
		case INIT:
			state = bHigher ? INITH : INITL;
			break;
		case INITH:
			state = bHigher ? INITH : L1;
			break;
		case L1:
		case H1:
			state = bHigher ? H1 : L1;
			break;
		case INITL:
			state = bHigher ? H2 : INITL;
			break;
		case H2:
		case L2:
			state = bHigher ? H2 : L2;
			break;
		default:
			ASSERT(false);
		}
		if(bHigher) {
			maxHigh = MAX(maxHigh, job->wcet);
		}
	}

					     
	switch (state) {
	case INITH:
	  type = H;
	  break;
	case INITL:
	  type = L;
	  break;
	case L1:
	  type = HL;
	  break;
	case H1:
	  type = HLH;
	  break;
	case H2:
	  type = LH;
      break;
	case L2:
	  type = LHL;
	  break;
	//In case i have no tasks, i.e., an empty task chain, treat myself as a L task which
	//does not matter.
	case INIT:
	  type = L;
	  break;
	default:
	  ASSERT(false);
	}
}
*/
